package com.ruoyi.spider.utils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.ruoyi.spider.helper.AjaxResult;
import com.ruoyi.spider.helper.Constants;
import com.ruoyi.spider.helper.StringUtils;
import org.apache.http.HttpEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.net.ssl.*;
import java.io.*;
import java.net.ConnectException;
import java.net.SocketTimeoutException;
import java.net.URL;
import java.net.URLConnection;
import java.security.cert.X509Certificate;

/**
 * 通用http发送方法
 *
 * @author ruoyi
 */
public class HttpUtils {
    private static final Logger log = LoggerFactory.getLogger(HttpUtils.class);

    public static String postBodyArt(String postUrl, String body, String accessToken) {
        try {
            CloseableHttpClient httpClient = HttpClients.createDefault();
            HttpPost httpPost = new HttpPost(postUrl);
            httpPost.setEntity(new StringEntity(body, ContentType.APPLICATION_JSON));
            if (StringUtils.isNotEmpty(accessToken)) {
                httpPost.setHeader("access-token", accessToken);
            }
            httpPost.setHeader("content-type", "application/json;charset=UTF-8");

            CloseableHttpResponse response = httpClient.execute(httpPost);
            String result = "";
            int statusCode = response.getStatusLine().getStatusCode();
            if (statusCode == 200 && response != null) {
                HttpEntity httpEntity = response.getEntity();
                // 如果返回的内容不为空
                if (httpEntity != null) {
                    result = EntityUtils.toString(httpEntity);
                }
            } else {
                log.info("error result data is {}", JSONObject.toJSONString(response));
            }
            response.close();
            httpClient.close();
            return result;
        } catch (Exception e) {
            log.error("postUrl is {}", postUrl);
            log.error(e.getMessage(), e);
        }
        return "";
    }

    /**
     * 处理专业线、招生计划、提前批这种加密请求
     * @param postUrl
     * @param body
     * @param uSign
     * @param accessToken
     * @param
     * @return
     */
    public static String postBody(String postUrl, String body, String uSign, String accessToken) {
        try {
            CloseableHttpClient httpClient = HttpClients.createDefault();
            HttpPost httpPost = new HttpPost(postUrl);
            httpPost.setEntity(new StringEntity(body, ContentType.APPLICATION_JSON));
            if (StringUtils.isNotEmpty(uSign)) {
                httpPost.setHeader("u-sign", uSign);
            }
            if (StringUtils.isNotBlank(accessToken)) {
                httpPost.setHeader("u-token", accessToken);
            }
            httpPost.setHeader("Content-Type", "application/json");

            httpPost.setHeader("Accept", "*/*");
            httpPost.setHeader("Accept-Encoding", "gzip, deflate, br");
            httpPost.setHeader("Connection", "keep-alive");
            httpPost.setHeader("Cookie", "acw_tc=2f624a4c16869760084986753e71a762c73c2548af36a442810ff5b3479420;path=/;HttpOnly;Max-Age=1800");
            httpPost.setHeader("Server", "nginx");
            httpPost.setHeader("Sec-Fetch-Site", "same-site");
            httpPost.setHeader("User-Agent", "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/114.0.0.0 Safari/537.36");
            httpPost.setHeader("Origin", "https://pv4y-pc.youzy.cn");
            httpPost.setHeader("Referer", "https://pv4y-pc.youzy.cn");
            httpPost.setHeader("sec-ch-ua-platform", "macOS");
            httpPost.setHeader("Sec-Ch-Ua-Mobile", "?0");
            httpPost.setHeader("sec-ch-ua", "Not.A/Brand\";v=\"8\", \"Chromium\";v=\"114\", \"Google Chrome\";v=\"114");
            httpPost.setHeader("Accept-Language", "zh-CN,zh;q=0.9,en;q=0.8");

            CloseableHttpResponse response = httpClient.execute(httpPost);
            String result = "";
            int statusCode = response.getStatusLine().getStatusCode();
            if (statusCode == 200 && response != null) {
                HttpEntity httpEntity = response.getEntity();
                // 如果返回的内容不为空
                if (httpEntity != null) {
                    result = EntityUtils.toString(httpEntity);
                }
            } else {
                log.info("error result data is {}", JSONObject.toJSONString(response));
            }
            return result;
        } catch (Exception e) {
            log.error("postUrl is {}", postUrl);
            log.error(e.getMessage(), e);
        }
        return "";
    }

    public static String postBodyJys(String postUrl, String body, String Cookie) {
        try {
            CloseableHttpClient httpClient = HttpClients.createDefault();
            HttpPost httpPost = new HttpPost(postUrl);
            httpPost.setEntity(new StringEntity(body, ContentType.APPLICATION_JSON));
            if (StringUtils.isNotEmpty(Cookie)) {
                httpPost.setHeader("Cookie", Cookie);
            }
            httpPost.setHeader("Content-Type", "application/json;charset=UTF-8");
            CloseableHttpResponse response = httpClient.execute(httpPost);
            String result = "";
            int statusCode = response.getStatusLine().getStatusCode();
            if (statusCode == 200 && response != null) {
                HttpEntity httpEntity = response.getEntity();
                // 如果返回的内容不为空
                if (httpEntity != null) {
                    result = EntityUtils.toString(httpEntity);
                }
            } else {

            }
            return result;
        } catch (Exception e) {
            log.error("postUrl is {}", postUrl);
            log.error(e.getMessage(), e);
        }
        return "";
    }

    public static String postBody(String postUrl, String body, String uSign) {
        return postBody(postUrl, body, uSign, null);
    }

    public static String postBody(String postUrl, String body) {
        return postBody(postUrl, body, null, null);
    }

    /**
     * @param url
     * @param param
     * @return
     */
    public static AjaxResult ajaxGet(String url, String param, Integer timeout) {
        String json = sendGet(url, param, timeout);
        return JSON.parseObject(json, AjaxResult.class);
    }

    public static AjaxResult ajaxGet(String url, String param) {
        return ajaxGet(url, param, null);
    }

    /**
     * 向指定 URL 发送GET方法的请求
     *
     * @param url   发送请求的 URL
     * @param param 请求参数，请求参数应该是 name1=value1&name2=value2 的形式。
     * @return 所代表远程资源的响应结果
     */
    public static String sendGet(String url, String param, Integer timeout) {
        return sendGet(url, param, Constants.UTF8, timeout);
    }

    public static String sendGet(String url, String param) {
        return sendGet(url, param, Constants.UTF8);
    }

    public static String sendGet(String url, String param, String contentType) {
        return sendGet(url, param, contentType, null);
    }

    /**
     * 向指定 URL 发送GET方法的请求
     *
     * @param url         发送请求的 URL
     * @param param       请求参数，请求参数应该是 name1=value1&name2=value2 的形式。
     * @param contentType 编码类型
     * @return 所代表远程资源的响应结果
     */
    public static String sendGet(String url, String param, String contentType, Integer timeout) {
        return sendGetArtAccessToken(url, param, contentType, timeout, null);
    }

    public static String sendGetArt(String url, String param, String accessToken) {
        return sendGetArtAccessToken(url, param, Constants.UTF8, null, accessToken);
    }


    public static String sendGetArtAccessToken(String url, String param, String contentType, Integer timeout, String accessToken) {
        StringBuilder result = new StringBuilder();
        BufferedReader in = null;
        try {
            String urlNameString = StringUtils.isNotBlank(param) ? url + "?" + param : url;
            log.debug("sendGet - {}", urlNameString);
            URL realUrl = new URL(urlNameString);
            URLConnection connection = realUrl.openConnection();
            if (null != timeout) {
                connection.setConnectTimeout(timeout);
                connection.setReadTimeout(timeout);
            }
            connection.setRequestProperty("content-type", "application/json;charset=UTF-8");
            connection.setRequestProperty("accept", "*/*");
            connection.setRequestProperty("connection", "Keep-Alive");
            connection.setRequestProperty("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
            if (StringUtils.isNotEmpty(accessToken)) {
                connection.setRequestProperty("access-token", accessToken);
            }
            connection.connect();
            in = new BufferedReader(new InputStreamReader(connection.getInputStream(), contentType));
            String line;
            while ((line = in.readLine()) != null) {
                result.append(line);
            }
            log.debug("recv - {}", result);
        } catch (ConnectException e) {
            log.error("调用HttpUtils.sendGet ConnectException, url=" + url + ",param=" + param, e);
        } catch (SocketTimeoutException e) {
            log.error("调用HttpUtils.sendGet SocketTimeoutException, url=" + url + ",param=" + param, e);
        } catch (IOException e) {
            log.error("调用HttpUtils.sendGet IOException, url=" + url + ",param=" + param, e);
        } catch (Exception e) {
            log.error("调用HttpsUtil.sendGet Exception, url=" + url + ",param=" + param, e);
        } finally {
            try {
                if (in != null) {
                    in.close();
                }
            } catch (Exception ex) {
                log.error("调用in.close Exception, url=" + url + ",param=" + param, ex);
            }
        }
        return result.toString();
    }


    /**
     * 向指定 URL 发送POST方法的请求
     *
     * @param url   发送请求的 URL
     * @param param 请求参数，请求参数应该是 name1=value1&name2=value2 的形式。
     * @return 所代表远程资源的响应结果
     */
    public static String sendPost(String url, String param) {
        PrintWriter out = null;
        BufferedReader in = null;
        StringBuilder result = new StringBuilder();
        try {
            String urlNameString = url;
            log.debug("sendPost - {}", urlNameString);
            URL realUrl = new URL(urlNameString);
            URLConnection conn = realUrl.openConnection();
            conn.setRequestProperty("accept", "*/*");
            conn.setRequestProperty("connection", "Keep-Alive");
            conn.setRequestProperty("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
            conn.setRequestProperty("Accept-Charset", "utf-8");
            conn.setRequestProperty("contentType", "utf-8");
            conn.setDoOutput(true);
            conn.setDoInput(true);
            out = new PrintWriter(conn.getOutputStream());
            out.print(param);
            out.flush();
            in = new BufferedReader(new InputStreamReader(conn.getInputStream(), "utf-8"));
            String line;
            while ((line = in.readLine()) != null) {
                result.append(line);
            }
            log.debug("recv - {}", result);
        } catch (ConnectException e) {
            log.error("调用HttpUtils.sendPost ConnectException, url=" + url + ",param=" + param, e);
        } catch (SocketTimeoutException e) {
            log.error("调用HttpUtils.sendPost SocketTimeoutException, url=" + url + ",param=" + param, e);
        } catch (IOException e) {
            log.error("调用HttpUtils.sendPost IOException, url=" + url + ",param=" + param, e);
        } catch (Exception e) {
            log.error("调用HttpsUtil.sendPost Exception, url=" + url + ",param=" + param, e);
        } finally {
            try {
                if (out != null) {
                    out.close();
                }
                if (in != null) {
                    in.close();
                }
            } catch (IOException ex) {
                log.error("调用in.close Exception, url=" + url + ",param=" + param, ex);
            }
        }
        return result.toString();
    }

    public static String sendSSLPost(String url, String param) {
        StringBuilder result = new StringBuilder();
        String urlNameString = url + "?" + param;
        try {
            log.debug("sendSSLPost - {}", urlNameString);
            SSLContext sc = SSLContext.getInstance("SSL");
            sc.init(null, new TrustManager[]{new TrustAnyTrustManager()}, new java.security.SecureRandom());
            URL console = new URL(urlNameString);
            HttpsURLConnection conn = (HttpsURLConnection) console.openConnection();
            conn.setRequestProperty("accept", "*/*");
            conn.setRequestProperty("connection", "Keep-Alive");
            conn.setRequestProperty("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
            conn.setRequestProperty("Accept-Charset", "utf-8");
            conn.setRequestProperty("contentType", "utf-8");
            conn.setDoOutput(true);
            conn.setDoInput(true);

            conn.setSSLSocketFactory(sc.getSocketFactory());
            conn.setHostnameVerifier(new TrustAnyHostnameVerifier());
            conn.connect();
            InputStream is = conn.getInputStream();
            BufferedReader br = new BufferedReader(new InputStreamReader(is));
            String ret = "";
            while ((ret = br.readLine()) != null) {
                if (ret != null && !"".equals(ret.trim())) {
                    result.append(new String(ret.getBytes("ISO-8859-1"), "utf-8"));
                }
            }
            log.debug("recv - {}", result);
            conn.disconnect();
            br.close();
        } catch (ConnectException e) {
            log.error("调用HttpUtils.sendSSLPost ConnectException, url=" + url + ",param=" + param, e);
        } catch (SocketTimeoutException e) {
            log.error("调用HttpUtils.sendSSLPost SocketTimeoutException, url=" + url + ",param=" + param, e);
        } catch (IOException e) {
            log.error("调用HttpUtils.sendSSLPost IOException, url=" + url + ",param=" + param, e);
        } catch (Exception e) {
            log.error("调用HttpsUtil.sendSSLPost Exception, url=" + url + ",param=" + param, e);
        }
        return result.toString();
    }

    private static class TrustAnyTrustManager implements X509TrustManager {
        @Override
        public void checkClientTrusted(X509Certificate[] chain, String authType) {
        }

        @Override
        public void checkServerTrusted(X509Certificate[] chain, String authType) {
        }

        @Override
        public X509Certificate[] getAcceptedIssuers() {
            return new X509Certificate[]{};
        }
    }

    private static class TrustAnyHostnameVerifier implements HostnameVerifier {
        @Override
        public boolean verify(String hostname, SSLSession session) {
            return true;
        }
    }
}
